IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'GERA_BOLETOS' AND
	           TYPE = 'P' 			     AND
              U.UID = O.UID           AND
              U.NAME = USER)

DROP PROCEDURE GERA_BOLETOS
GO

CREATE PROCEDURE GERA_BOLETOS
    @P_CDFILIAL    VARCHAR(04),
    @P_NRLANCTONF  VARCHAR(10),
    @P_CDFILILANC  VARCHAR(04),
    @P_NRLANBOLREC VARCHAR(10),
    @P_CDTPCTRECEB VARCHAR(06),
    @P_IDEXCBOLREC VARCHAR(01) = 'N',
    @P_CDFILBOLORI VARCHAR(04) = NULL,
    @P_NRLANBOLORI VARCHAR(10) = NULL

AS

   DECLARE @V_CDCLIENTE     VARCHAR(21);
   DECLARE @V_CDEMPRESA     VARCHAR(02);
   DECLARE @V_CDFILIEMIT    VARCHAR(04);
   DECLARE @V_VRPEMULBREC   NUMERIC(10,3);
   DECLARE @V_VRMULTABREC   NUMERIC(10,3);
   DECLARE @V_VRPEMORBREC   NUMERIC(10,3);
   DECLARE @V_VRMORABREC    NUMERIC(10,3);

   DECLARE @V_CDSERIE       VARCHAR(05);
   DECLARE @V_NRNOTAFISC    VARCHAR(10);
   DECLARE @V_NRINSJURNF    VARCHAR(20);
   DECLARE @V_IDSISTEMA     VARCHAR(03);

   DECLARE @V_CDCLASSFINA   VARCHAR(06);
   DECLARE @V_CDCLASSAJUS   VARCHAR(06);
   DECLARE @V_NRLANBOLREC   VARCHAR(10);
   DECLARE @V_NRLANBOLAUX   VARCHAR(10);

   DECLARE @V_VRPARCELAS    FLOAT;
   DECLARE @V_NRPARCELAS    FLOAT;
   DECLARE @V_NRCONTADOR    FLOAT;
   DECLARE @V_VRTOTACONT    NUMERIC(16,2);
   DECLARE @V_VRACUMULADO   NUMERIC(16,2);
   DECLARE @V_VRAJUSTEBO    NUMERIC(16,2);

   DECLARE @V_CDFIMFLUXO    VARCHAR(04);
   DECLARE @V_IDCALPREVREC  VARCHAR(01);
   DECLARE @V_NRREGFOR      INTEGER;

   DECLARE @V_CDCONTREDUGB  VARCHAR(03);
   DECLARE @V_CDTPBAIXAREC  VARCHAR(02);
   DECLARE @V_DTVENBOLREC   DATETIME;
   DECLARE @V_CDFILIAL      VARCHAR(4);

   DECLARE @V_CDCARTCOBR    VARCHAR(03);
   DECLARE @V_IDCARTCOBR    VARCHAR(01);
   DECLARE @V_IDIMPRBOLETO  VARCHAR(01);
   DECLARE @V_QTDIAPROTEST  NUMERIC(11);
   DECLARE @V_CDINS1COBR_1  VARCHAR(02);
   DECLARE @V_CDINS2COBR_1  VARCHAR(02);
   DECLARE @V_CDDIAPROTEST  VARCHAR(01);
   DECLARE @V_QTDIASPREREC  FLOAT;

   DECLARE @V_CDBANCO        VARCHAR(03);
   DECLARE @V_IDPRIORBPREF   VARCHAR(01);
   DECLARE @V_QTDIAPRORCNT   NUMERIC(15);
   DECLARE @V_IDCOFERIBANC   VARCHAR(01);
   DECLARE @V_DATAVENCCTAREC DATETIME;
   DECLARE @V_CDINS1COBR     VARCHAR(02);
   DECLARE @V_CDINS2COBR     VARCHAR(02);
   DECLARE @V_CDTIPORECE     VARCHAR(03);
   DECLARE @V_NRLANCCONT     VARCHAR(12);
   DECLARE @V_NRSEQLANC      VARCHAR(05);
   DECLARE @V_VRNOTAFISC     FLOAT;
   DECLARE @V_VRCONTAREC     FLOAT;

   DECLARE @V_NMRAZSOCCLIE   VARCHAR(50);
   DECLARE @V_NMFANTCLIE     VARCHAR(50);
   DECLARE @V_NMTPBAIXAREC   VARCHAR(50);
   DECLARE @V_TIPOBAIXA      INTEGER;
   DECLARE @V_CDTPBAIXA      VARCHAR(02);

   DECLARE @V_MULT           NUMERIC(16,2);

   DECLARE @V_DTFLUXO        DATETIME;

   /* VARIVEIS DO CURSOR V_CONTARECEBER */
   DECLARE @V_CONTARECEBER_NRSEQVENREC  VARCHAR(02);
   DECLARE @V_CONTARECEBER_DTATUAVENREC DATETIME;
   DECLARE @V_CONTARECEBER_DTORIGVENREC DATETIME;
   DECLARE @V_CONTARECEBER_VRATUAREC    NUMERIC(16,2);
   DECLARE @V_CONTARECEBER_CDFILIBOLREC VARCHAR(04);
   DECLARE @V_CONTARECEBER_NRLANBOLREC  VARCHAR(10);
   DECLARE @V_CONTARECEBER_CDEMPRESA    VARCHAR(02);
   DECLARE @V_CONTARECEBER_CDFIMOVFLREC VARCHAR(04);
   DECLARE @V_CONTARECEBER_DTMOVFLUXO   DATETIME;
   DECLARE @V_CONTARECEBER_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_CONTARECEBER_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_CONTARECEBER_VRORIGREC    NUMERIC(16,2);
   DECLARE @V_CONTARECEBER_NRPARCELAREC VARCHAR(02);
   DECLARE @V_CONTARECEBER_IDSTATREC    VARCHAR(01);
   DECLARE @V_CONTARECEBER_DTPREVRECEBI DATETIME;
   DECLARE @V_CONTARECEBER_QTDIASPREREC FLOAT;
   DECLARE @V_CONTARECEBER_NRLANCTODUP  VARCHAR(10);

   /* VARIVEIS DO CURSOR C_FERIBC */
   DECLARE @V_FERIBC_DTFERIBANC   DATETIME;

   /* VARIVEIS DO CURSOR C_AJUSTE */
   DECLARE @V_AJUSTE_VRTOTIMPONF NUMERIC(15,2);
   DECLARE @V_AJUSTE_CDAJUCTREC  VARCHAR(04);

   /* VARIVEIS DO CURSOR C_AJUSTECNT */
   DECLARE @V_AJUSTECNT_CDFILIAL     VARCHAR(04);
   DECLARE @V_AJUSTECNT_NRLANCTONF   VARCHAR(10);
   DECLARE @V_AJUSTECNT_NRSEQVENREC  VARCHAR(02);
   DECLARE @V_AJUSTECNT_NRPARCELAREC VARCHAR(02);
   DECLARE @V_AJUSTECNT_DTAJUSTEREC  DATETIME;
   DECLARE @V_AJUSTECNT_CDAJUCTREC   VARCHAR(04);
   DECLARE @V_AJUSTECNT_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_AJUSTECNT_CDEMMFAJCNTR VARCHAR(02);
   DECLARE @V_AJUSTECNT_CDFIMFAJCNTR VARCHAR(04);
   DECLARE @V_AJUSTECNT_DTMOVFLUXO   DATETIME;
   DECLARE @V_AJUSTECNT_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_AJUSTECNT_VRAJUSTEREC  NUMERIC(16,2);
   DECLARE @V_AJUSTECNT_IDAJUCTREC   VARCHAR(01);

   /* VARIVEIS DO CURSOR C_RATTPCTR */
   DECLARE @V_RATTPCTR_CDTPCTRECEB  VARCHAR(06);
   DECLARE @V_RATTPCTR_CDCENTCUST   VARCHAR(04);
   DECLARE @V_RATTPCTR_CDFILIAL     VARCHAR(04);
   DECLARE @V_RATTPCTR_CDFIRATTPCTR VARCHAR(04);
   DECLARE @V_RATTPCTR_VRPERATTPCTR NUMERIC(15,2);

   DECLARE @V_CDTPCTRECEB VARCHAR(6);

BEGIN
   SELECT @V_CDCLIENTE = N.CDCLIENTE, @V_CDEMPRESA = N.CDEMPRESA, @V_CDFILIEMIT = N.CDFILIEMIT,
          @V_CDSERIE = N.CDSERIE, @V_NRNOTAFISC = N.NRNOTAFISC, @V_NRINSJURNF = N.NRINSJURNF,
          @V_VRPEMULBREC = ISNULL(C.VRPEMULBCLI, VRPEMULEMPR),
          @V_VRPEMORBREC = ISNULL(C.VRPEMORBCLI, E.VRPEMOREMPR),
          @V_IDSISTEMA = N.IDSISTEMA,
          @V_NRLANCCONT = N.NRLANCTBDOC, @V_VRNOTAFISC = N.VRNOTAFISC
     FROM NOTAFISCAL N LEFT JOIN CLIENTE C
                              ON N.CDCLIENTE  = C.CDCLIENTE,
         EMPRESA E
   WHERE N.CDFILIAL   = @P_CDFILIAL     AND
         N.NRLANCTONF = @P_NRLANCTONF   AND
         N.CDEMPRESA  = E.CDEMPRESA;

   SELECT @V_CDCLASSFINA = MAX(CDCLASSFINA)
   FROM TIPOCTRECEBER
   WHERE CDTPCTRECEB = @P_CDTPCTRECEB;

   SELECT @V_IDCALPREVREC = MAX(ISNULL(IDCALPREVREC, 'V')) 
   FROM PARAMGERAL;

   IF (@P_CDFILBOLORI IS NULL) AND (@P_NRLANBOLORI IS NULL) BEGIN
      SELECT @V_CDCONTREDUGB = MAX(BF.CDREDUCONT), @V_IDPRIORBPREF = MAX(BF.IDPRIORBPREF),
             @V_CDBANCO = MAX(BF.CDBANCO), @V_CDINS1COBR = MAX(BF.CDINS1COBRCL),
             @V_CDINS2COBR = MAX(BF.CDINS2COBRCL)
        FROM BANCOPREF BF, CONTCORR  CC
       WHERE CC.CDEMPRESA = @V_CDEMPRESA
         AND CC.CDREDUCONT = BF.CDREDUCONT
         AND BF.CDCLIENTE = @V_CDCLIENTE
         AND BF.IDPRIORBPREF = 'S';

      IF (NOT @V_CDBANCO IS NULL) BEGIN
         SELECT @V_QTDIAPRORCNT = MAX(QTDIAPRORCNT)
           FROM BANCO
          WHERE CDBANCO = @V_CDBANCO;

         SELECT @V_IDCOFERIBANC = MAX(IDCOFERIBANC)
         FROM PARAMGERAL;
      END;
   END;

   SELECT @V_CDTPBAIXAREC = MAX(CDTPBAIXAREC)
     FROM PARAMFILIAL
    WHERE CDFILIAL = (SELECT CDFILIEMIT
                        FROM NOTAFISCAL
                       WHERE CDFILIAL = @P_CDFILIAL
                         AND NRLANCTONF = @P_NRLANCTONF);

   IF @V_CDCONTREDUGB IS NULL BEGIN
      SELECT @V_CDCONTREDUGB = MAX(CDREDUGBFILI), @V_CDFILIAL = MAX(CDFILIAL)
        FROM PARAMFILIAL
       WHERE CDFILIAL = (SELECT CDFILIEMIT
                           FROM NOTAFISCAL
                          WHERE CDFILIAL = @P_CDFILIAL
                            AND NRLANCTONF = @P_NRLANCTONF);
      IF NOT @V_CDCONTREDUGB IS NULL BEGIN
         SET @V_CDINS1COBR = NULL;
         SET @V_CDINS2COBR = NULL;

         SELECT @V_CDCONTREDUGB = MAX(CC.CDREDUCONT)
           FROM CONTCORR CC, FILIAL FI
          WHERE CC.CDEMPRESA = FI.CDEMPRESA
            AND FI.CDFILIAL = @V_CDFILIAL
            AND CC.CDREDUCONT = @V_CDCONTREDUGB;
      END;
   END;

   IF @V_CDCONTREDUGB IS NULL BEGIN
     SELECT @V_CDCONTREDUGB = MAX(P.CDREDUGBEMPR)
       FROM PARAMEMPRESA P
      WHERE P.CDEMPRESA = @V_CDEMPRESA;
   END;

   IF NOT @V_CDCONTREDUGB IS NULL BEGIN
      SELECT @V_CDINS1COBR_1 = MAX(E.CDINS1COBR),
             @V_CDINS2COBR_1 = MAX(E.CDINS2COBR),
             @V_CDCARTCOBR = MAX(E.CDCARTCOBR),
             @V_IDCARTCOBR = MAX(E.IDCARTCOBR),
             @V_IDIMPRBOLETO = MAX(E.IDIMPRBOLETO),
             @V_QTDIAPROTEST = MAX(E.QTDIAPROTEST),
             @V_CDDIAPROTEST = MAX(E.CDDIAPROTEST)
        FROM EMPRBANC E, CONTCORR C
       WHERE E.CDEMPRESA = @V_CDEMPRESA
         AND E.CDBANCO = C.CDBANCO
         AND C.CDREDUCONT = @V_CDCONTREDUGB;

      IF @V_CDINS1COBR IS NULL AND @V_CDINS2COBR IS NULL BEGIN
         SET @V_CDINS1COBR = @V_CDINS1COBR_1;
         SET @V_CDINS2COBR = @V_CDINS2COBR_1;
      END;
   END;

   IF @V_CDTPBAIXAREC IS NULL BEGIN
      SELECT @V_CDTPBAIXAREC = MAX(CDTPBAIXAREC)
        FROM PARAMEMPRESA
       WHERE CDEMPRESA = @V_CDEMPRESA;
   END;

   IF (@V_IDSISTEMA = 'PED') OR (@V_IDSISTEMA = 'EXP') BEGIN
      SELECT DISTINCT @V_CDTIPORECE = MAX(MO.CDTIPORECE)
        FROM PEDIDO PE, ITEMPRODUTO IP, MODPGTO MO
       WHERE MO.CDMODPGTO = PE.CDMODPGTO
         AND IP.CDFILIALPED = PE.CDFILIAL
         AND IP.NRPEDIDO = PE.NRPEDIDO
         AND IP.CDFILIAL = @P_CDFILIAL
         AND IP.NRLANCTONF  = @P_NRLANCTONF;
   END;

   SET @V_NRPARCELAS = 0;
   SET @V_NRLANBOLREC = @P_NRLANBOLREC;

   DECLARE C_CONTARECEBER CURSOR FOR
   SELECT C.NRSEQVENREC, C.DTATUAVENREC, C.DTORIGVENREC,
          C.VRATUAREC, C.CDFILIBOLREC, C.NRLANBOLREC,
          C.CDEMPRESA, C.CDFIMOVFLREC, C.DTMOVFLUXO,
          C.IDMOVFLUXO, C.CDCLASSFINA, C.VRORIGREC,
          C.NRPARCELAREC, C.IDSTATREC, C.DTPREVRECEBI,
          C.QTDIASPREREC
   FROM CONTARECEBER C LEFT JOIN DUPLICATA D
                     ON C.CDFILIALDUP = D.CDFILIAL
                    AND C.NRLANCTODUP = D.NRLANCTODUP
   WHERE C.CDFILIAL = @P_CDFILIAL
     AND C.NRLANCTONF = @P_NRLANCTONF
     AND (D.NRLANCTODUP IS NULL OR D.CDINTEGDUP IS NOT NULL)
   ORDER BY NRSEQVENREC;

   OPEN C_CONTARECEBER;
   FETCH NEXT FROM C_CONTARECEBER INTO @V_CONTARECEBER_NRSEQVENREC,  @V_CONTARECEBER_DTATUAVENREC,
                                       @V_CONTARECEBER_DTORIGVENREC, @V_CONTARECEBER_VRATUAREC,
                                       @V_CONTARECEBER_CDFILIBOLREC, @V_CONTARECEBER_NRLANBOLREC,
                                       @V_CONTARECEBER_CDEMPRESA,    @V_CONTARECEBER_CDFIMOVFLREC,
                                       @V_CONTARECEBER_DTMOVFLUXO,   @V_CONTARECEBER_IDMOVFLUXO,
                                       @V_CONTARECEBER_CDCLASSFINA,  @V_CONTARECEBER_VRORIGREC,
                                       @V_CONTARECEBER_NRPARCELAREC, @V_CONTARECEBER_IDSTATREC,
                                       @V_CONTARECEBER_DTPREVRECEBI, @V_CONTARECEBER_QTDIASPREREC;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@P_CDFILBOLORI IS NULL AND @P_NRLANBOLORI IS NULL) OR
         (@V_CONTARECEBER_CDFILIBOLREC = @P_CDFILBOLORI AND @V_CONTARECEBER_NRLANBOLREC = @P_NRLANBOLORI) BEGIN

         IF (@P_CDFILBOLORI IS NULL) AND (@P_NRLANBOLORI IS NULL) BEGIN
            IF (NOT @V_CDBANCO IS NULL) BEGIN
               SET @V_DATAVENCCTAREC = ISNULL(@V_CONTARECEBER_DTPREVRECEBI, @V_CONTARECEBER_DTATUAVENREC);
               SET @V_CONTARECEBER_DTATUAVENREC = @V_CONTARECEBER_DTORIGVENREC;
               IF (NOT @V_QTDIAPRORCNT IS NULL) BEGIN
                  SET @V_CONTARECEBER_DTATUAVENREC = @V_CONTARECEBER_DTATUAVENREC + @V_QTDIAPRORCNT;
               END;
               IF @V_IDCOFERIBANC = 'S' BEGIN
                  DECLARE C_FERIBC CURSOR FOR
                  SELECT DTFERIBANC
                  FROM FERIBANC
                  WHERE
                     (CDFILIAL = @P_CDFILIAL) AND
                     (DTFERIBANC >= @V_CONTARECEBER_DTATUAVENREC);

                  OPEN C_FERIBC;

                  FETCH NEXT FROM C_FERIBC INTO @V_FERIBC_DTFERIBANC;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     IF @V_FERIBC_DTFERIBANC = @V_CONTARECEBER_DTATUAVENREC BEGIN
                        SET @V_CONTARECEBER_DTATUAVENREC = @V_CONTARECEBER_DTATUAVENREC + 1;
                     END
                     ELSE BEGIN
                        RETURN;
                     END;
                     FETCH NEXT FROM C_FERIBC INTO @V_FERIBC_DTFERIBANC;
                  END;
                  CLOSE C_FERIBC;
                  DEALLOCATE C_FERIBC;
               END;
            END;
         END;

         IF @P_IDEXCBOLREC = 'S' BEGIN
            /* - NA EXCLUSO DA DUPLICATA VOLTA TODOS OS VENCIMENTOS PARA DATA ORIGINAL - */
            SET @V_DTVENBOLREC = @V_CONTARECEBER_DTORIGVENREC;
         END
         ELSE BEGIN
            SET @V_DTVENBOLREC = @V_CONTARECEBER_DTATUAVENREC;
         END;

         SET @V_TIPOBAIXA = 0;

         SELECT @V_TIPOBAIXA = COUNT(*)
           FROM CLIENTE CL, TIPOBAIXAREC TP
          WHERE TP.CDTPBAIXAREC = CL.CDTPBAIXAREC
            AND CL.CDCLIENTE = @V_CDCLIENTE;

         IF @V_TIPOBAIXA > 0 BEGIN
            SELECT @V_CDTPBAIXA = CL.CDTPBAIXAREC, @V_CDCLIENTE = CL.CDCLIENTE
              FROM CLIENTE CL, TIPOBAIXAREC TP
             WHERE TP.CDTPBAIXAREC = CL.CDTPBAIXAREC
               AND CL.CDCLIENTE = @V_CDCLIENTE
            ORDER BY CL.NMRAZSOCCLIE;

            IF NOT @V_CDTPBAIXA IS NULL BEGIN
               SET @V_CDTPBAIXAREC = @V_CDTPBAIXA;
            END;
         END;

         /*CALCULA O VALOR DA MULTA CONFORME PERCENTUAL PARAMETRIZADO*/
         SET @V_VRMULTABREC = 0;
         IF @V_VRPEMULBREC > 0 BEGIN
            SET @V_VRMULTABREC = @V_CONTARECEBER_VRATUAREC * @V_VRPEMULBREC / 100;
         END;

         /*CALCULA O VALOR DA MORA DIRIA CONFORME PERCENTUAL PARAMETRIZADO*/
         SET @V_VRMORABREC = 0;
         IF @V_VRPEMORBREC > 0 BEGIN
            SET @V_VRMORABREC = @V_CONTARECEBER_VRATUAREC * @V_VRPEMORBREC / 100;
         END;

         SET @V_NRLANBOLAUX = @V_NRLANBOLREC;
         IF (@V_IDSISTEMA = 'PDV') AND (@V_CONTARECEBER_IDSTATREC = 'P') BEGIN
            SET @V_NRLANBOLREC = @V_CONTARECEBER_NRLANBOLREC;
            UPDATE BOLETRECEBER
            SET VRBOLREC     = @V_CONTARECEBER_VRATUAREC,
                VRFINALBREC  = @V_CONTARECEBER_VRATUAREC,
                DTVENBOLREC  = @V_DTVENBOLREC,
                VRPEMULBREC  = @V_VRPEMULBREC,
                VRMULTABREC  = @V_VRMULTABREC,
                VRPEMORBREC  = @V_VRPEMULBREC,
                VRMORDIABREC = @V_VRMORABREC,
                CDINS1COBBOL = @V_CDINS1COBR,
                CDINS2COBBOL = @V_CDINS2COBR,
                CDCARTCOBBOL = @V_CDCARTCOBR,
                IDCARTCOBREC = @V_IDCARTCOBR,
                IDIMPRBOLBOL = @V_IDIMPRBOLETO,
                QTDIAPROTBOL = @V_QTDIAPROTEST,
                CDDIAPROTBOL = @V_CDDIAPROTEST
            WHERE
               CDFILIAL    = @P_CDFILILANC AND
               NRLANBOLREC = @V_NRLANBOLREC;
         END
         ELSE BEGIN
            INSERT INTO BOLETRECEBER
               (CDFILIAL,     NRLANBOLREC,  CDCLIENTE,    CDEMPRESA,
                VRBOLREC,     VRFINALBREC,  DTVENBOLREC,  CDTPBAIXAREC,
                IDSTATBREC,   VRPEMULBREC,  VRMULTABREC,  VRPEMORBREC,
                VRMORDIABREC, CDREDUCONT,   CDINS1COBBOL, CDINS2COBBOL,
                CDCARTCOBBOL, IDCARTCOBREC, IDIMPRBOLBOL, QTDIAPROTBOL,
                CDDIAPROTBOL)
            VALUES
               (@P_CDFILILANC, @V_NRLANBOLREC, @V_CDCLIENTE, @V_CDEMPRESA,
                @V_CONTARECEBER_VRATUAREC, @V_CONTARECEBER_VRATUAREC, @V_DTVENBOLREC, @V_CDTPBAIXAREC,
                'A', @V_VRPEMULBREC, @V_VRMULTABREC, @V_VRPEMORBREC,
                @V_VRMORABREC, @V_CDCONTREDUGB, @V_CDINS1COBR, @V_CDINS2COBR,
                @V_CDCARTCOBR, @V_IDCARTCOBR, @V_IDIMPRBOLETO, @V_QTDIAPROTEST, @V_CDDIAPROTEST);
         END;

         IF (NOT @V_CDTIPORECE IS NULL) BEGIN
            INSERT INTO TPRECBOLETO
               (CDFILIAL,   NRLANBOLREC, NRSEQTPRECBO,
                CDTIPORECE, VRTPRECBOLR)
            VALUES
               (@P_CDFILILANC, @V_NRLANBOLREC, '01',
                @V_CDTIPORECE, @V_CONTARECEBER_VRATUAREC);
         END;

         IF @V_CONTARECEBER_QTDIASPREREC IS NULL BEGIN
            IF @V_IDCALPREVREC = '6' BEGIN
               SELECT @V_QTDIASPREREC = ISNULL(QTPREVRECCLI, 0)
                 FROM CLIENTE
                WHERE CDCLIENTE = @V_CDCLIENTE;
            END
            ELSE BEGIN
               SET @V_QTDIASPREREC = 0;
            END;
         END
         ELSE BEGIN
            SET @V_QTDIASPREREC = @V_CONTARECEBER_QTDIASPREREC;
         END;

         /* - VERIFICA SE O PROCEDURE EST SENDO CHAMADA DA PROCEDURE DE EXCLUSO DE DUPLICATA - */
         IF @P_IDEXCBOLREC = 'S' BEGIN
            IF @V_CONTARECEBER_DTORIGVENREC + @V_QTDIASPREREC <> @V_CONTARECEBER_DTATUAVENREC BEGIN
               /* - ATUALIZA O FLUXO DE CAIXA -------------------------- */
               IF @V_CONTARECEBER_DTMOVFLUXO IS NOT NULL BEGIN

                  SET @V_MULT = @V_CONTARECEBER_VRORIGREC * -1;
                  EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CONTARECEBER_CDEMPRESA,
                                               @V_CONTARECEBER_CDFIMOVFLREC,
                                               @V_CONTARECEBER_DTMOVFLUXO,
                                               @V_CONTARECEBER_IDMOVFLUXO,
                                               @V_CONTARECEBER_CDCLASSFINA,
                                               @V_MULT,
                                               0;
               END;

               SET @V_DTFLUXO = @V_CONTARECEBER_DTORIGVENREC + @V_QTDIASPREREC;

               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CONTARECEBER_CDEMPRESA,
                                            @V_CONTARECEBER_CDFIMOVFLREC,
                                            @V_DTFLUXO,
                                            @V_CONTARECEBER_IDMOVFLUXO,
                                            @V_CONTARECEBER_CDCLASSFINA,
                                            @V_CONTARECEBER_VRORIGREC,
                                            0;

               /* -- ATUALIZA O FLUXO DE CAIXA DOS AJUSTES DA CONTA -------------*/
               SELECT @V_NRREGFOR = COUNT(*)
                 FROM AJCTRECEBER
                WHERE CDFILIAL = @P_CDFILIAL
                  AND NRLANCTONF = @P_NRLANCTONF
                  AND NRSEQVENREC = @V_CONTARECEBER_NRSEQVENREC
                  AND NRPARCELAREC = @V_CONTARECEBER_NRPARCELAREC;

               IF @V_NRREGFOR > 0 BEGIN
                  DECLARE C_AJUSTECNT CURSOR FOR
                  SELECT
                     AJ.CDFILIAL, AJ.NRLANCTONF, AJ.NRSEQVENREC,
                     AJ.NRPARCELAREC, AJ.DTAJUSTEREC, AJ.CDAJUCTREC,
                     AJ.CDCLASSFINA, AJ.CDEMMFAJCNTR, AJ.CDFIMFAJCNTR,
                     AJ.DTMOVFLUXO, AJ.IDMOVFLUXO, AJ.VRAJUSTEREC, TA.IDAJUCTREC
                  FROM
                     AJCTRECEBER   AJ,
                     TIPOAJRECEBER TA
                  WHERE
                     (AJ.CDFILIAL     = @P_CDFILIAL)            AND
                     (AJ.NRLANCTONF   = @P_NRLANCTONF)          AND
                     (AJ.NRSEQVENREC  = @V_CONTARECEBER_NRSEQVENREC)  AND
                     (AJ.NRPARCELAREC = @V_CONTARECEBER_NRPARCELAREC) AND
                     (TA.CDAJUCTREC   = AJ.CDAJUCTREC);

                  OPEN C_AJUSTECNT;

                  FETCH NEXT FROM C_AJUSTECNT INTO @V_AJUSTECNT_CDFILIAL, @V_AJUSTECNT_NRLANCTONF,
                                                   @V_AJUSTECNT_NRSEQVENREC, @V_AJUSTECNT_NRPARCELAREC,
                                                   @V_AJUSTECNT_DTAJUSTEREC, @V_AJUSTECNT_CDAJUCTREC,
                                                   @V_AJUSTECNT_CDCLASSFINA, @V_AJUSTECNT_CDEMMFAJCNTR,
                                                   @V_AJUSTECNT_CDFIMFAJCNTR, @V_AJUSTECNT_DTMOVFLUXO,
                                                   @V_AJUSTECNT_IDMOVFLUXO, @V_AJUSTECNT_VRAJUSTEREC,
                                                   @V_AJUSTECNT_IDAJUCTREC;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SET @V_MULT = @V_AJUSTECNT_VRAJUSTEREC * -1;

                     IF @V_AJUSTECNT_IDAJUCTREC = 'A' BEGIN

                        EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTECNT_CDEMMFAJCNTR,
                                                     @V_AJUSTECNT_CDFIMFAJCNTR,
                                                     @V_AJUSTECNT_DTMOVFLUXO,
                                                     @V_AJUSTECNT_IDMOVFLUXO,
                                                     @V_AJUSTECNT_CDCLASSFINA,
                                                     @V_MULT,
                                                     0;

                        EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTECNT_CDEMMFAJCNTR,
                                                     @V_AJUSTECNT_CDFIMFAJCNTR,
                                                     @V_CONTARECEBER_DTORIGVENREC,
                                                     @V_AJUSTECNT_IDMOVFLUXO,
                                                     @V_AJUSTECNT_CDCLASSFINA,
                                                     @V_AJUSTECNT_VRAJUSTEREC,
                                                     0;
                     END
                     ELSE BEGIN
                        EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTECNT_CDEMMFAJCNTR,
                                                     @V_AJUSTECNT_CDFIMFAJCNTR,
                                                     @V_AJUSTECNT_DTMOVFLUXO,
                                                     @V_AJUSTECNT_IDMOVFLUXO,
                                                     @V_AJUSTECNT_CDCLASSFINA,
                                                     @V_AJUSTECNT_VRAJUSTEREC,
                                                     0;


                        EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTECNT_CDEMMFAJCNTR,
                                                     @V_AJUSTECNT_CDFIMFAJCNTR,
                                                     @V_CONTARECEBER_DTORIGVENREC,
                                                     @V_AJUSTECNT_IDMOVFLUXO,
                                                     @V_AJUSTECNT_CDCLASSFINA,
                                                     @V_MULT,
                                                     0;
                     END;

                     /* -- ALTERA A CHAVE DO MOVIMENTO DO FLUXO -------------*/
                     UPDATE AJCTRECEBER
                        SET DTMOVFLUXO = @V_CONTARECEBER_DTORIGVENREC
                      WHERE CDFILIAL = @V_AJUSTECNT_CDFILIAL
                        AND NRLANCTONF = @V_AJUSTECNT_NRLANCTONF
                        AND NRSEQVENREC = @V_AJUSTECNT_NRSEQVENREC
                        AND NRPARCELAREC = @V_AJUSTECNT_NRPARCELAREC
                        AND DTAJUSTEREC = @V_AJUSTECNT_DTAJUSTEREC
                        AND CDAJUCTREC = @V_AJUSTECNT_CDAJUCTREC
                        AND CDCLASSFINA = @V_AJUSTECNT_CDCLASSFINA;

                     FETCH NEXT FROM C_AJUSTECNT INTO @V_AJUSTECNT_CDFILIAL, @V_AJUSTECNT_NRLANCTONF,
                                                      @V_AJUSTECNT_NRSEQVENREC, @V_AJUSTECNT_NRPARCELAREC,
                                                      @V_AJUSTECNT_DTAJUSTEREC, @V_AJUSTECNT_CDAJUCTREC,
                                                      @V_AJUSTECNT_CDCLASSFINA, @V_AJUSTECNT_CDEMMFAJCNTR,
                                                      @V_AJUSTECNT_CDFIMFAJCNTR, @V_AJUSTECNT_DTMOVFLUXO,
                                                      @V_AJUSTECNT_IDMOVFLUXO, @V_AJUSTECNT_VRAJUSTEREC,
                                                      @V_AJUSTECNT_IDAJUCTREC;

                  END;
                  CLOSE C_AJUSTECNT;
                  DEALLOCATE C_AJUSTECNT;
               END;
            END;

            /* -- ALTERA A CHAVE DO MOVIMENTO DO FLUXO E DO BOLETO-------------*/
            UPDATE CONTARECEBER
            SET CDFILIBOLREC = @P_CDFILILANC,
                NRLANBOLREC = @V_NRLANBOLREC,
                DTATUAVENREC = @V_CONTARECEBER_DTORIGVENREC,
                CDMOTIPROR = NULL,
                QTDIASPREREC = @V_QTDIASPREREC,
                DTPREVRECEBI = @V_CONTARECEBER_DTORIGVENREC + @V_QTDIASPREREC,
                DTMOVFLUXO = @V_CONTARECEBER_DTORIGVENREC + @V_QTDIASPREREC
            WHERE CDFILIAL = @P_CDFILIAL           AND
                  NRLANCTONF = @P_NRLANCTONF         AND
                  NRSEQVENREC = @V_CONTARECEBER_NRSEQVENREC AND
                  NRPARCELAREC = @V_CONTARECEBER_NRPARCELAREC;
         END
         ELSE BEGIN
            /*RETORNA O TIPO DE CONTA JA CADASTRADO*/
            SELECT @V_CDTPCTRECEB = CDTPCTRECEB
              FROM CONTARECEBER
             WHERE CDFILIAL     = @P_CDFILIAL           AND
                   NRLANCTONF   = @P_NRLANCTONF         AND
                   NRSEQVENREC  = @V_CONTARECEBER_NRSEQVENREC AND
                   NRPARCELAREC = @V_CONTARECEBER_NRPARCELAREC;

            /* SE O TIPO NO ESTIVER CADASTRADO SALVA O TIPO PADRO */
            IF (@V_CDTPCTRECEB IS NULL) BEGIN
               SET @V_CDTPCTRECEB = @P_CDTPCTRECEB;
            END;
            
            IF @V_CONTARECEBER_DTMOVFLUXO IS NOT NULL BEGIN
               /* - ATUALIZA O FLUXO DE CAIXA -------------------------- */
               SET @V_MULT = @V_CONTARECEBER_VRORIGREC * -1;
               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                            @V_CDFILIEMIT,
                                            @V_CONTARECEBER_DTMOVFLUXO,
                                            'E',
                                            @V_CDCLASSFINA,
                                            @V_MULT,
                                            0;
            END;

            SET @V_DTFLUXO = @V_CONTARECEBER_DTORIGVENREC + @V_QTDIASPREREC;

            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                         @V_CDFILIEMIT,
                                         @V_DTFLUXO,
                                         'E',
                                         @V_CDCLASSFINA,
                                         @V_CONTARECEBER_VRORIGREC,
                                         0;

            UPDATE CONTARECEBER
            SET CDTPCTRECEB = @V_CDTPCTRECEB,
                CDFILIBOLREC = @P_CDFILILANC,
                NRLANBOLREC = @V_NRLANBOLREC,
                DTATUAVENREC = @V_CONTARECEBER_DTORIGVENREC,
                CDCLASSFINA = @V_CDCLASSFINA,
                CDEMPRESA = @V_CDEMPRESA,
                CDFIMOVFLREC = @V_CDFILIEMIT,
                QTDIASPREREC = @V_QTDIASPREREC,
                DTPREVRECEBI = @V_DTFLUXO,
                DTMOVFLUXO = @V_DTFLUXO,
                IDMOVFLUXO = 'E',
                DSCONTAREC = SUBSTRING(ISNULL(DSCONTAREC,'NF: '+@V_NRINSJURNF+' - '+@V_NRNOTAFISC+' - '+@V_CDSERIE),1,100)
            WHERE CDFILIAL = @P_CDFILIAL
              AND NRLANCTONF = @P_NRLANCTONF
              AND NRSEQVENREC = @V_CONTARECEBER_NRSEQVENREC
              AND NRPARCELAREC = @V_CONTARECEBER_NRPARCELAREC;

            SET @V_NRCONTADOR = 1;
            SET @V_VRACUMULADO = 0;

            DELETE RATCTRECEBER
             WHERE CDFILIAL = @P_CDFILIAL
               AND NRLANCTONF = @P_NRLANCTONF
               AND NRSEQVENREC = @V_CONTARECEBER_NRSEQVENREC;

            SELECT @V_NRSEQLANC = MAX(NRSEQLANC)
              FROM LANCCONT
             WHERE CDEMPRESA = @V_CDEMPRESA
               AND NRLANCCONT = @V_NRLANCCONT
               AND VRLANCAMENT = (SELECT MAX(VRLANCAMENT)
                                    FROM LANCCONT
                                   WHERE CDEMPRESA  = @V_CDEMPRESA
                                     AND NRLANCCONT = @V_NRLANCCONT);

            IF @V_NRSEQLANC IS NOT NULL BEGIN

               DECLARE C_RATTPCTR CURSOR FOR
                SELECT LC.CDCENTCUST, LC.CDFILIAL, (VRLANCCUST/VRLANCAMENT) AS VRPERATTPCTR
                  FROM LANCCCUSTO LC, LANCCONT L
                 WHERE LC.CDEMPRESA = @V_CDEMPRESA
                   AND LC.NRLANCCONT = @V_NRLANCCONT
                   AND LC.NRSEQLANC = @V_NRSEQLANC
                   AND L.CDEMPRESA = @V_CDEMPRESA
                   AND L.NRLANCCONT = @V_NRLANCCONT
                   AND L.NRSEQLANC = @V_NRSEQLANC;

               OPEN C_RATTPCTR;

               FETCH NEXT FROM C_RATTPCTR INTO @V_RATTPCTR_CDCENTCUST,
                                               @V_RATTPCTR_CDFILIAL,
                                               @V_RATTPCTR_VRPERATTPCTR;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SET @V_VRPARCELAS = ROUND(@V_CONTARECEBER_VRATUAREC * @V_RATTPCTR_VRPERATTPCTR, 2);
                  SET @V_VRACUMULADO = @V_VRACUMULADO + @V_VRPARCELAS;

                  IF @V_NRPARCELAS = @V_NRCONTADOR BEGIN
                     IF @V_VRACUMULADO > @V_CONTARECEBER_VRATUAREC BEGIN
                        SET @V_VRPARCELAS = ROUND(@V_VRPARCELAS - (ABS(@V_CONTARECEBER_VRATUAREC - @V_VRACUMULADO)),2);
                     END
                     ELSE BEGIN
                        IF @V_VRACUMULADO < @V_CONTARECEBER_VRATUAREC BEGIN
                           SET @V_VRPARCELAS = ROUND(@V_VRPARCELAS + (ABS(@V_CONTARECEBER_VRATUAREC - @V_VRACUMULADO)),2);
                        END;
                     END;
                  END;
                  INSERT INTO RATCTRECEBER
                     (CDFILIAL, NRLANCTONF, NRSEQVENREC, NRPARCELAREC,
                      CDCENTCUST, CDFIRATCTREC, VRRATCCCTREC)
                  VALUES
                     (@P_CDFILIAL, @P_NRLANCTONF, @V_CONTARECEBER_NRSEQVENREC, @V_CONTARECEBER_NRPARCELAREC,
                      @V_RATTPCTR_CDCENTCUST, @V_RATTPCTR_CDFILIAL, @V_VRPARCELAS);

                  SET @V_NRCONTADOR = @V_NRCONTADOR + 1;

                  FETCH NEXT FROM C_RATTPCTR INTO @V_RATTPCTR_CDCENTCUST,
                                                  @V_RATTPCTR_CDFILIAL,
                                                  @V_RATTPCTR_VRPERATTPCTR;

               END;
               CLOSE C_RATTPCTR;
               DEALLOCATE C_RATTPCTR;
            END
            ELSE BEGIN
               SELECT @V_NRPARCELAS = COUNT(*)
                 FROM RATTPCTR
                WHERE CDTPCTRECEB = @P_CDTPCTRECEB;

               IF @V_NRPARCELAS > 0 BEGIN
                  DECLARE C_RATTPCTR CURSOR FOR
                  SELECT LC.CDCENTCUST, LC.CDFILIAL, (VRLANCCUST/VRLANCAMENT) AS VRPERATTPCTR
                    FROM LANCCCUSTO LC, LANCCONT L
                   WHERE LC.CDEMPRESA = @V_CDEMPRESA
                     AND LC.NRLANCCONT = @V_NRLANCCONT
                     AND LC.NRSEQLANC = @V_NRSEQLANC
                     AND L.CDEMPRESA = @V_CDEMPRESA
                     AND L.NRLANCCONT = @V_NRLANCCONT
                     AND L.NRSEQLANC = @V_NRSEQLANC;

                  OPEN C_RATTPCTR;

                  FETCH NEXT FROM C_RATTPCTR INTO @V_RATTPCTR_CDCENTCUST,
                                                  @V_RATTPCTR_CDFILIAL,
                                                  @V_RATTPCTR_VRPERATTPCTR;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SET @V_VRPARCELAS = ROUND(@V_CONTARECEBER_VRATUAREC * @V_RATTPCTR_VRPERATTPCTR, 2);
                     SET @V_VRACUMULADO = @V_VRACUMULADO + @V_VRPARCELAS;

                     IF @V_NRPARCELAS = @V_NRCONTADOR BEGIN
                        IF @V_VRACUMULADO > @V_CONTARECEBER_VRATUAREC BEGIN
                           SET @V_VRPARCELAS = ROUND(@V_VRPARCELAS - (ABS(@V_CONTARECEBER_VRATUAREC - @V_VRACUMULADO)),2);
                        END
                        ELSE BEGIN
                           IF @V_VRACUMULADO < @V_CONTARECEBER_VRATUAREC BEGIN
                              SET @V_VRPARCELAS = ROUND(@V_VRPARCELAS + (ABS(@V_CONTARECEBER_VRATUAREC - @V_VRACUMULADO)),2);
                           END;
                        END;
                     END;
                     INSERT INTO RATCTRECEBER
                        (CDFILIAL, NRLANCTONF, NRSEQVENREC, NRPARCELAREC,
                         CDCENTCUST, CDFIRATCTREC, VRRATCCCTREC)
                     VALUES
                        (@P_CDFILIAL, @P_NRLANCTONF, @V_CONTARECEBER_NRSEQVENREC, @V_CONTARECEBER_NRPARCELAREC,
                         @V_RATTPCTR_CDCENTCUST, @V_RATTPCTR_CDFILIAL, @V_VRPARCELAS);

                     SET @V_NRCONTADOR = @V_NRCONTADOR + 1;

                     FETCH NEXT FROM C_RATTPCTR INTO @V_RATTPCTR_CDCENTCUST,
                                                     @V_RATTPCTR_CDFILIAL,
                                                     @V_RATTPCTR_VRPERATTPCTR;

                  END;
                  CLOSE C_RATTPCTR;
                  DEALLOCATE C_RATTPCTR;
               END;
            END;
         END;

         IF (@V_IDSISTEMA = 'PDV') AND (@V_CONTARECEBER_IDSTATREC = 'P') BEGIN
            SET @V_NRLANBOLREC = @V_NRLANBOLAUX;
         END;

         SET @V_NRLANBOLREC = RIGHT(REPLICATE('0',10)+CONVERT(VARCHAR,CONVERT(INTEGER,@V_NRLANBOLREC) + 1), 10);
      END;
      FETCH NEXT FROM C_CONTARECEBER INTO @V_CONTARECEBER_NRSEQVENREC, @V_CONTARECEBER_DTATUAVENREC,
                                          @V_CONTARECEBER_DTORIGVENREC, @V_CONTARECEBER_VRATUAREC,
                                          @V_CONTARECEBER_CDFILIBOLREC, @V_CONTARECEBER_NRLANBOLREC,
                                          @V_CONTARECEBER_CDEMPRESA, @V_CONTARECEBER_CDFIMOVFLREC,
                                          @V_CONTARECEBER_DTMOVFLUXO, @V_CONTARECEBER_IDMOVFLUXO,
                                          @V_CONTARECEBER_CDCLASSFINA, @V_CONTARECEBER_VRORIGREC,
                                          @V_CONTARECEBER_NRPARCELAREC, @V_CONTARECEBER_IDSTATREC,
                                          @V_CONTARECEBER_DTPREVRECEBI, @V_CONTARECEBER_QTDIASPREREC;
   END;
   CLOSE C_CONTARECEBER;
   DEALLOCATE C_CONTARECEBER;


   SELECT @V_NRPARCELAS = COUNT(*), @V_VRTOTACONT = SUM(VRATUAREC)
     FROM CONTARECEBER
    WHERE CDFILIAL = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;

   DECLARE C_AJUSTE CURSOR FOR
   SELECT ISNULL(SUM(IT.VRTOTIMPONF),0) AS VRTOTIMPONF, I.CDAJUCTREC
   FROM IMPOSNFTOT IT, IMPOSTO I
   WHERE IT.CDFILIAL    = @P_CDFILIAL   AND
         IT.NRLANCTONF  = @P_NRLANCTONF AND
         IT.CDIMPOSTO   = I.CDIMPOSTO  AND
         I.IDTRATIMPO   = 'R'          AND
         I.IDDESCRFONTE = 'A'
   GROUP BY I.CDAJUCTREC;


   OPEN C_AJUSTE;

   FETCH NEXT FROM C_AJUSTE INTO @V_AJUSTE_VRTOTIMPONF, @V_AJUSTE_CDAJUCTREC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_AJUSTE_VRTOTIMPONF > 0 BEGIN
         SET @V_NRCONTADOR = 1;
         SET @V_VRACUMULADO = ROUND(@V_AJUSTE_VRTOTIMPONF, 2);

         DECLARE C_CONTARECEBER CURSOR FOR
         SELECT NRSEQVENREC, DTATUAVENREC, VRATUAREC,
                CDFILIBOLREC, NRLANBOLREC, NRLANCTODUP,
                CDEMPRESA, NRPARCELAREC, CDCLASSFINA,
                CDFIMOVFLREC, DTPREVRECEBI
           FROM CONTARECEBER
          WHERE CDFILIAL = @P_CDFILIAL
            AND NRLANCTONF = @P_NRLANCTONF
         ORDER BY NRSEQVENREC;


         OPEN C_CONTARECEBER;
         FETCH NEXT FROM C_CONTARECEBER INTO @V_CONTARECEBER_NRSEQVENREC, @V_CONTARECEBER_DTATUAVENREC,
                                             @V_CONTARECEBER_VRATUAREC, @V_CONTARECEBER_CDFILIBOLREC,
                                             @V_CONTARECEBER_NRLANBOLREC, @V_CONTARECEBER_NRLANCTODUP,
                                             @V_CONTARECEBER_CDEMPRESA, @V_CONTARECEBER_NRPARCELAREC,
                                             @V_CONTARECEBER_CDCLASSFINA, @V_CONTARECEBER_CDFIMOVFLREC,
                                             @V_CONTARECEBER_DTPREVRECEBI;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF @V_NRPARCELAS = @V_NRCONTADOR BEGIN
               SET @V_VRAJUSTEBO = ROUND(@V_VRACUMULADO, 2);
            END
            ELSE BEGIN
               SET @V_VRAJUSTEBO  = ROUND((@V_AJUSTE_VRTOTIMPONF/@V_VRTOTACONT) * @V_CONTARECEBER_VRATUAREC, 2);
               SET @V_VRACUMULADO = ROUND(@V_VRACUMULADO, 2) - ROUND(@V_VRAJUSTEBO, 2);
            END;

            IF @V_CONTARECEBER_CDCLASSFINA IS NULL BEGIN
               SET @V_CDCLASSAJUS = @V_CDCLASSFINA;
            END
            ELSE BEGIN
               SET @V_CDCLASSAJUS = @V_CONTARECEBER_CDCLASSFINA;
            END;

            IF @V_CONTARECEBER_CDFIMOVFLREC IS NULL BEGIN
               SET @V_CDFIMFLUXO = @V_CDFILIEMIT;
            END
            ELSE BEGIN
               SET @V_CDFIMFLUXO = @V_CONTARECEBER_CDFIMOVFLREC;
            END;

            IF @V_CONTARECEBER_NRLANCTODUP IS NULL BEGIN
               SET @V_MULT = @V_VRAJUSTEBO * -1;

               SET @V_DATAVENCCTAREC = ISNULL(@V_CONTARECEBER_DTPREVRECEBI, @V_CONTARECEBER_DTATUAVENREC);

               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CONTARECEBER_CDEMPRESA,
                                            @V_CDFIMFLUXO,
                                            @V_DATAVENCCTAREC,
                                            'E',
                                            @V_CDCLASSAJUS,
                                            @V_MULT,
                                            0;

               INSERT INTO AJBOLREC
                  (CDFILIAL, NRLANBOLREC, CDAJUCTREC, VRAJBOLREC)
               VALUES
                  (@P_CDFILILANC, @V_CONTARECEBER_NRLANBOLREC, @V_AJUSTE_CDAJUCTREC, @V_VRAJUSTEBO);

               INSERT INTO MOVFXAJBOLR
                  (CDFILIBOLREC, NRLANBOLREC, CDAJUCTREC,
                   CDCLASSFINA,  CDEMPRESA,   CDFILIAL,
                   DTMOVFLUXO,   IDMOVFLUXO,  VRFXAJBOLREC)
               VALUES
                  (@P_CDFILILANC, @V_CONTARECEBER_NRLANBOLREC, @V_AJUSTE_CDAJUCTREC,
                   @V_CDCLASSAJUS, @V_CONTARECEBER_CDEMPRESA, @V_CDFIMFLUXO,
                   ISNULL(@V_CONTARECEBER_DTPREVRECEBI, @V_CONTARECEBER_DTATUAVENREC), 'E', @V_VRAJUSTEBO);

               UPDATE BOLETRECEBER
                  SET VRFINALBREC = ROUND((VRFINALBREC - @V_VRAJUSTEBO),2)
                WHERE CDFILIAL = @P_CDFILILANC
                  AND NRLANBOLREC = @V_CONTARECEBER_NRLANBOLREC;
            END;
            SET @V_NRCONTADOR = @V_NRCONTADOR + 1;

            FETCH NEXT FROM C_CONTARECEBER INTO @V_CONTARECEBER_NRSEQVENREC,  @V_CONTARECEBER_DTATUAVENREC,
                                                @V_CONTARECEBER_VRATUAREC,    @V_CONTARECEBER_CDFILIBOLREC,
                                                @V_CONTARECEBER_NRLANCTODUP,  @V_CONTARECEBER_CDEMPRESA,
                                                @V_CONTARECEBER_NRPARCELAREC, @V_CONTARECEBER_CDCLASSFINA,
                                                @V_CONTARECEBER_CDFIMOVFLREC, @V_CONTARECEBER_DTPREVRECEBI;

         END;
         CLOSE C_CONTARECEBER;
         DEALLOCATE C_CONTARECEBER;
      END;
      FETCH NEXT FROM C_AJUSTE INTO @V_AJUSTE_VRTOTIMPONF, @V_AJUSTE_CDAJUCTREC;
   END;
   CLOSE C_AJUSTE;
   DEALLOCATE C_AJUSTE;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_BOLETOS','5.42.xxx';
GO

